# Hanging chain problem
model;

param nh;     # number of subintervals
param L > 0;  # length of the suspended chain
param a;      # height of the chain at t=0 (left)
param b;      # height of the chain at t=1 (right)

param tf;         # ODEs defined in [0,tf]
param h := tf/nh; # uniform interval length
var x{0..nh};     # height of the chain
var u{0..nh};     # derivative of x 

minimize potential_energy:
 0.5*h*sum {i in 0..nh-1} (x[i]*sqrt(1+u[i]^2)+x[i+1]*sqrt(1+u[i+1]^2));

subject to x_eqn {j in 0..nh-1}:
  x[j+1] = x[j] + 0.5*h*(u[j] + u[j+1]);

subject to length_eqn:
  0.5*h*sum {i in 0..nh-1} (sqrt(1+u[i]^2) + sqrt(1+u[i+1]^2)) = L;

# Boundary conditions

subject to x_bc1: x[0] = a;
subject to x_bc2: x[nh] = b;
